<template>
  <tasks-view color="green" title="Done" icon="check-circle">
    <template v-slot:tasks>
      <div v-for="[day, tasks] of days" :key="day" class="mb-8">
        <div class="font-bold pb-2 mb-2">
          {{ day }}
        </div>
        <tasks-item
          v-for="task of tasks"
          :key="task.id"
          :task="task"
          class="mt-1"
          workspace
          hide-focus
          :thin="responsive.isMobile"
        />
      </div>
      <infinite-loading @infinite="loadMore($event)">
        <template v-slot:spinner>
          <div class="flex flex-row justify-center">
            <loader-vue color="green" class="w-8 h-8" />
          </div>
        </template>
      </infinite-loading>
    </template>
  </tasks-view>
</template>

<script lang="ts">
import Task from "@/models/Task";
import { computed } from "vue";
import TasksItem from "@/components/Tasks/Item.vue";
import ViewHeader from "@/components/ViewHeader.vue";
import { Loader } from "@/use/Loader";
import LoaderVue from "@/components/Loader.vue";
import InfiniteLoading from "@/vue-infinite-loading/src/components/InfiniteLoading.vue";
import TasksView from "@/components/Tasks/TasksView.vue";
import responsive from "@/use/responsive";

class GroupedArray<Key, Item> extends Map<Key, Item[]> {
  push(group: Key, ...item: Item[]) {
    if (!this.has(group)) {
      this.set(group, []);
    }
    return this.get(group)!.push(...item);
  }
}

export default {
  components: { TasksItem, ViewHeader, LoaderVue, InfiniteLoading, TasksView },
  setup() {
    const loader = new Loader();
    let query = Task.query()
      .apply("done")
      .orderBy("doneAt", "desc")
      .skip(0)
      .limit(30);

    const days = computed(() => {
      const tasks = query
        .limit(query.$getQuery()._skip! + query.$getQuery()._limit!)
        .skip(0)
        .getSync();
      const ordered = new GroupedArray();
      for (const task of tasks) {
        ordered.push(task.doneAt!.toRelativeCalendar(), task);
      }
      return [...ordered.entries()];
    });
    return {
      responsive,
      loader,
      days,
      loadMore: ($state: any) => {
        query.get().then(result => {
          if (result.length == 0) {
            $state.complete();
          } else {
            query = query.skip(query.$getQuery()._skip! + query.$getQuery()._limit!);
            $state.loaded();
          }
        });
      }
    };
  }
};
</script>
